/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */

#ifndef _JS_RUNTIME_H_
#define _JS_RUNTIME_H_

#include <lstLib.h>
#ifdef THREADS
#ifdef VX
# include <semLib.h>
# else
# include <pthread.h>
# endif
#endif
#include "js-context.h"
#include "js-rootnew.h"
#include "js-gcheap.h"
#include "js-heap.h"

/* Classes */
class JSContext;
class JSScriptable;
#ifdef COMPACT_MEM
class JSGCStringHashtable;
#endif
class JSRuntime: public JSRootNew {
	public:
#ifdef COMPACT_MEM
		class Allocator {
			public:
				JSRuntime   *runtime;

			public:
				Allocator(JSRuntime *cx) {
					this->runtime = runtime;
				}

				void    *allocate(size_t size) {
					return JS_NewRuntimeObj(runtime, size);
				}
				void    deallocate(void *obj) {
					JS_DeleteRuntimeObj(runtime, obj);
				}
		} ;
#endif
		class GCAllocator {
			public:
				JSRuntime       *runtime;

			public:
				GCAllocator(JSRuntime *runtime) {
					this->runtime = runtime;
				}

				void    *allocate(size_t size) {
					return runtime->gcHeap.newObj(
												JSContext::getCurrentContext(),
												size);
				}
				void    deallocate(void *obj) {
				}
		} ;

	protected:
#ifdef THREADS
# ifdef VX
		SEM_ID          mutex;
		SEM_ID          cond;
		SEM_ID          condWorld;
		int             holder;
# else
		pthread_mutex_t mutex;
		pthread_cond_t  cond;
		pthread_cond_t  condWorld;
		pthread_t       holder;
# endif
		int             level;
#endif
		LIST            contexts;
#ifdef THREADS
		int             enterCount;
		int             stopCount;
#endif

#ifdef COMPACT_MEM
		JSGCStringHashtable
						*gcStringHashtable;
#endif

	public:
		JSGCHeap        gcHeap;

		JSHeap          heap;          //disindependent from ewb's mem Part
		ByteCodeHeap    byteCodeHeap;  //disindependent from ByteCode's mem Part
		JSLocalHeap     localHeap;     //independence mem Part for GC
		JSZoneLocalHeap localZoneHeap; //independence mem Part for zone memory

		GCAllocator     allocator;

		int             numRoots;
		JSScriptable    **roots;

		jsVal_t         NaNobj;
#ifdef COMPACT_MEM
		Allocator       _allocator;
#endif
		static  JSRuntime  *keepedRuntime2;
#ifdef STATS
		static  JSRuntime  *keepedRuntime;
#endif


	public:
		JSRuntime(int maxBytes);
		~JSRuntime();

		void	cleanup();
		void    enter();
		void    exit();

		void    lock();
		void    unlock();

		void    addContext(JSContext *cx);
		void    delContext(JSContext *cx);

		void    markAll();
		void    stopWorld();
		void    resumeWorld();

		void    addRoot(JSScriptable *rootObj);
		void    removeRoot(JSScriptable *rootObj);
#ifdef COMPACT_MEM
		jsString_t
				hasGCString(jsString_t string);
		void    setGCString(jsString_t string);
		void    organizeGCString();
#endif
} ;

#endif /* _JS_RUNTIME_H_ */

